package top.ninwoo.test.CsvMerge;


import top.ninwoo.test.doMap.DoMap;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.util.Arrays;
import java.util.Date;

public class GetTopo {
    public static void main(String[] args){



        String str;
        String str1;
        String str2;
        //传输时间参数
        str = ReadFile.date+" 5-00-00";
        System.out.println(Arrays.deepToString(TopoRequire(str)));
        //传输当前时间
        Date current = new Date();
        Date current1 = new Date(current.getTime()+ (long)DoMap.slot);
        Date current2 = new Date(current1.getTime()+ (long)DoMap.slot);
        SimpleDateFormat sdf = new SimpleDateFormat(
                "yyyy-MM-dd HH-mm-ss");
        str = sdf.format(current);
        str1 = sdf.format(current1);
        str2 = sdf.format(current2);









    }

    public static int[][] TopoRequire(String str) {
        //网络信息表
        NodeL[][] parse = ReadFile.parse();

        LocalDate dateC = LocalDate.now();
        ReadFile.date = dateC.getYear()+"-"+dateC.getMonthValue()+"-"+dateC.getDayOfMonth();

        Long timeMillis= getTim(str);
        int[][] topo = getTp(parse,timeMillis);
        topo = reshape(topo);
//        System.out.println(Arrays.deepToString(topo));
        return topo;
    }





    private static int[][] reshape(int[][] topo) {
        int[][] topos = new int[30][30];
        for (int i =0;i<30;i++){
            for (int j = 0;j<30;j++){
                topos[i][j] = topo[i][j];
            }
        }
        return topos;
    }


    public static Long getTim(String dateL){
        long time = 0L;
        SimpleDateFormat sDF = new SimpleDateFormat("yyyy-MM-dd HH-mm-ss");
        try {
            time = sDF.parse(dateL).getTime();
        } catch (ParseException e) {
            e.printStackTrace();
        }finally {
            return time;
        }

    }



    public static int[][] getTp(NodeL[][] parse,Long timeMillis) {
        int high = parse.length;
        int width = parse[0].length;
        int[][] result = new int[high][width];
        for (int i =0;i<high;i++){
            for (int j = 0;j<width;j++){
                NodeL tmp = parse[i][j];
                while (tmp!=null){
                    if (tmp.start<=timeMillis && tmp.end>=timeMillis) {
                        result[i][j] = 1;
                        break;
                    }
                    tmp = tmp.next;
                }
                if (tmp==null) result[i][j]=0;
            }
        }
        return result;
    }
}

