package top.ninwoo.test.CsvMerge;

import java.io.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.Iterator;

public class ReadFile {
    /*
     * 拓扑连接信息存储于矩阵NodeLS,
     *
     * */
    public static void main(String[] args){
        LocalDate dateC = LocalDate.now();
        date = dateC.getYear()+"-"+dateC.getMonthValue()+"-"+dateC.getDayOfMonth();
        NodeL[][] parse = ReadFile.parse();
        long timeMillis = System.currentTimeMillis();
        System.out.print(timeMillis);
    }





    public static NodeL[][] parse(){

        File csv = new File("leo72.csv");
//        D:\LabratoryJavaPro\
        BufferedReader br = null;
        try {
            br = new BufferedReader(new FileReader(csv));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }

        String line = "";
        String everyLine = "";
        ArrayList<String> allString = new ArrayList<>();
        //处理每行数据
        try {
            line=br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
        }
        while (line!=null){
            everyLine = line;
            String[] strings = everyLine.split(",");
            for (String s: strings){
                if (s.charAt(0)=='L'){
                    int count = 0;
                    StringBuffer str = new StringBuffer();
                    str.append('L');
                    for (int qq=1;qq<s.length();qq++){
                        if (s.charAt(qq)-'0'<10 && s.charAt(qq)-'0'>=0){
                            str.append(s.charAt(qq));
                            count++;
                        }
                        if (count==3) str.append(' ');
                    }
                    s = str.toString();
                }
//                System.out.println(s);
                allString.add(s);
            }

            try {
                line=br.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
//        System.out.println("csv表格中所有行数："+allString.size());
        //处理字符链表至矩阵链表
        NodeL[][] nodeLS = new NodeL[6*12][6*12];
        //定位矩阵索引位
        Iterator<String> allSItr = allString.iterator();
        //规避重复项
        allSItr.next();
        while (allSItr.hasNext()){
            String next = allSItr.next();
            //解析轨道行
            if (next.charAt(0)=='L'){
                //转化字符串为数字
                String[] s = new String[2];
                split(next,s);
                //获取节点索引位置
                int row = Integer.valueOf(s[0].substring(1));
                int column = Integer.valueOf(s[1]);
                //轨道面与节点编号转换公式
                row = (row/100-1)*12+row%100-1;
                column = (column/100-1)*12+column%100-1;
                // 解析时间行
                // 将读取数据转化为long型
                NodeL tmp = null;
                while (allSItr.hasNext()){
                    next = allSItr.next();
                    if (next.charAt(0)!='L'){
                        Long start = shift(next);
//                        System.out.println(start);
                        next = allSItr.next();
                        Long end = shift(next);
                        NodeL nodeL = new NodeL(start,end);
                        if (tmp ==null) nodeLS[row][column] = nodeL;
                        if (tmp!=null) tmp.next=nodeL;
                        tmp = nodeL;
                    }else break;
                }
                //显示赋值节点元素
            /*System.out.print("拓扑第"+row+"行，第"+column+"列元素"+'\t');
            NodeL show = nodeLS[row][column];
            while (show!=null){
                System.out.print("start="+show.start+"  end="+show.end+'\t');
                show = show.next;
            }
            System.out.println();*/
            }
        }
        //填充链表
//        System.out.println(nodeLS.);
        return nodeLS;
    }

    private static void split(String next, String[] s) {
        StringBuffer sbr = new StringBuffer(next);
        int posi = 0;
        int index = 0;
        int start = 0;
        for (;index<sbr.length();index++){
            if (sbr.charAt(index)==' ')
            {
                s[posi++] = sbr.substring(start,index);
                while (index<sbr.length() && sbr.charAt(index)==' ') index++;
                start=index;
            }
            s[posi] = sbr.substring(start,index+1);
        }
    }

    public static String date = "1970-1-2";
    private static Long shift(String next) {
        long time = 0L;
        StringBuffer sbr = new StringBuffer(next);
        for (int d= 0;d<sbr.length();d++){
            if (sbr.charAt(d)==':') sbr.setCharAt(d,'-');
        }
        String dateL = date+" "+sbr;
        SimpleDateFormat sDF = new SimpleDateFormat("yyyy-MM-dd HH-mm-ss");
        try {
            time = sDF.parse(dateL).getTime();
        } catch (ParseException e) {
            e.printStackTrace();
        }finally {
            return time;
        }

    }



}

class NodeL{
    public Long start;
    public Long end;
    public NodeL next = null;

    public NodeL(Long start, Long end) {
        this.start = start;
        this.end = end;
    }
}